{-# LANGUAGE ScopedTypeVariables #-}

import Control.Exception
import Control.Concurrent

-- Catch an error call inside an IO action.
catcherr :: IO ()-> IO ()
catcherr io = catch io handler where
  -- Need explicit signature for handler here
  handler :: ErrorCall -> IO ()
  handler e = putStrLn "An error call has been caught (and ignored)."


ex1 :: IO ()
ex1 = do
  m <- newEmptyMVar
  forkIO (do {s<- takeMVar m; putStrLn s})
  threadDelay (100000)
  catcherr $ putMVar m (error "FOO!")

ex2 :: IO ()
ex2 = do
  m <- newEmptyMVar
  forkIO (catcherr (do {s<- takeMVar m; putStrLn s}))
  threadDelay (100000)
  putMVar m (error "FOO!")

ex3 :: IO ()
ex3 = catcherr $ do
  m <- newEmptyMVar
  forkIO (do {s<- takeMVar m; putStrLn s})
  threadDelay (100000)
  putMVar m (error "FOO!")

