module Robots3 where

import Control.Concurrent
import System.Random

data Robot = Robot {id :: Int, pos :: Int, battery :: Int}

instance Show Robot where
  show (Robot i p b) = "Robot #"++ show i++ " at "++ show p++ " [battery: "++ show b++ "]"

-- Move given robot by n units in separate thread, 
-- return a future which gets filled once movement is complete
move :: Robot-> Int-> IO (MVar Robot)
move r n = do
  f <- newEmptyMVar; forkIO (mv f r n); return f where
  mv f r n
   | n <= 0 || battery r <= 0 = putMVar f r
   | otherwise =  do
      m<- randomRIO(0,10); threadDelay(m*100000)
      putStrLn $ "Bleep, bleep: "++ show r
      mv f r{pos= pos r+ 1, battery= battery r- 1} (n-1)

