module RobotsEx3 where

import Control.Concurrent
import Control.Monad(when)
import System.Random
import Robots3

ex :: IO ()
ex = do
  let swarm = [Robot i 0 10 | i<- [1 .. numRobots]]
  fs <- mapM (\r-> do { n <- randomRIO (0, 10); move r n }) swarm
  putStrLn "Started moving robots..."
  cnt <- newMVar numRobots
  finished <- newEmptyMVar
  mapM_ (\v-> forkIO (watchRobot v cnt finished)) fs
  takeMVar finished
  putStrLn "Finished moving robots..."
  where
    numRobots = 6
    watchRobot v cnt f = do
      r<- takeMVar v
      c<- modifyMVar cnt $ \c-> return (c-1, c-1)
      putStrLn $ "Finished: "++ show r++ "(" ++ show c ++ " robots left.)"
      when (c == 0) $ putMVar f ()
                  
